# coding: utf-8

"""
    Sencity API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from sencity_client.configuration import Configuration


class Incident(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'hub_guid': 'str',
        'timestamp': 'datetime',
        'module_guid': 'str',
        'payload': 'str'
    }

    attribute_map = {
        'hub_guid': 'hub_guid',
        'timestamp': 'timestamp',
        'module_guid': 'module_guid',
        'payload': 'payload'
    }

    def __init__(self, hub_guid=None, timestamp=None, module_guid=None, payload=None, local_vars_configuration=None):  # noqa: E501
        """Incident - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._hub_guid = None
        self._timestamp = None
        self._module_guid = None
        self._payload = None
        self.discriminator = None

        self.hub_guid = hub_guid
        self.timestamp = timestamp
        self.module_guid = module_guid
        self.payload = payload

    @property
    def hub_guid(self):
        """Gets the hub_guid of this Incident.  # noqa: E501


        :return: The hub_guid of this Incident.  # noqa: E501
        :rtype: str
        """
        return self._hub_guid

    @hub_guid.setter
    def hub_guid(self, hub_guid):
        """Sets the hub_guid of this Incident.


        :param hub_guid: The hub_guid of this Incident.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and hub_guid is None:  # noqa: E501
            raise ValueError("Invalid value for `hub_guid`, must not be `None`")  # noqa: E501

        self._hub_guid = hub_guid

    @property
    def timestamp(self):
        """Gets the timestamp of this Incident.  # noqa: E501


        :return: The timestamp of this Incident.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this Incident.


        :param timestamp: The timestamp of this Incident.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    @property
    def module_guid(self):
        """Gets the module_guid of this Incident.  # noqa: E501


        :return: The module_guid of this Incident.  # noqa: E501
        :rtype: str
        """
        return self._module_guid

    @module_guid.setter
    def module_guid(self, module_guid):
        """Sets the module_guid of this Incident.


        :param module_guid: The module_guid of this Incident.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and module_guid is None:  # noqa: E501
            raise ValueError("Invalid value for `module_guid`, must not be `None`")  # noqa: E501

        self._module_guid = module_guid

    @property
    def payload(self):
        """Gets the payload of this Incident.  # noqa: E501


        :return: The payload of this Incident.  # noqa: E501
        :rtype: str
        """
        return self._payload

    @payload.setter
    def payload(self, payload):
        """Sets the payload of this Incident.


        :param payload: The payload of this Incident.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and payload is None:  # noqa: E501
            raise ValueError("Invalid value for `payload`, must not be `None`")  # noqa: E501

        self._payload = payload

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Incident):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Incident):
            return True

        return self.to_dict() != other.to_dict()
